<?php
if (!defined('DC_CONTEXT_ADMIN')) { return; }

$name = 'shortURL';

# Get versions
$this_version = $core->plugins->moduleInfo($name, 'version');
$installed_version = $core->getVersion($name);
if (version_compare($installed_version, $this_version, '>=')) {
	return;
}

function putShurlGlobalSetting($id,$value,$type=null,$label=null,$value_change=true) {
	global $core;
	$old_value = $core->blog->settings->shortURL->get($id);
	if ($old_value === null)
		$core->blog->settings->shortURL->put($id,$value,$type,$label,$value_change,true);
	else
		$core->blog->settings->shortURL->put($id,$old_value,$type,$label,$value_change,true);
}

# Install or update
try
{
	# Check DC version
	if (!version_compare(DC_VERSION, '2.2', '>='))
	{
		throw new Exception(sprintf(__('Plugin %1$s version %2$s requires Dotclear 2.2 or later.'), $name, $this_version));
	}

	//... ici ce qu'on veut faire pendant l'installation. (ou même rien)
	$core->blog->settings->addNamespace('shortURL');
	putShurlGlobalSetting('shortURLEnabled',false,'boolean','Enable short URL system');
	putShurlGlobalSetting('shortURLPrefix','shurl','string','Short URL system prefix');
	putShurlGlobalSetting('shortURLCommentPrefix','shurlc','string','Short URL system prefix for comments');
	putShurlGlobalSetting('shortURLBackCompatibility',false,'boolean','Still support the old URL system (ie the \'postid\' prefix)');

	$core->setVersion($name, $this_version);

	return true;
}
catch (Exception $e)
{
	$core->error->add($e->getMessage());
	return false;
}
?>

