<?php
if (!defined('DC_RC_PATH')) { return; }

$core->tpl->addValue('EntryShortURL',array('tplShortURL','EntryShortURL'));
$core->tpl->addValue('CommentShortURL',array('tplShortURL','CommentShortURL'));

class tplShortURL
{
	public static function EntryShortURL($attr)
	{
		$f = $GLOBALS['core']->tpl->getFilters($attr);
		if ($GLOBALS['core']->blog->settings->shortURL->shortURLEnabled) {
			if ($GLOBALS['core']->blog->settings->shortURL->shortURLEvenShorter) {
				$id = 'dcShortURL::idConversion($_ctx->posts->post_id)';
			} else {
				$id = '$_ctx->posts->post_id';
			}
			return '<?php echo '.sprintf($f,'$core->blog->url.$core->url->getBase("shortURL").'.
				'"/".rawurlencode('.$id.')').'; ?>';
		}
		return '';
	}

	public static function CommentShortURL($attr)
	{
		$f = $GLOBALS['core']->tpl->getFilters($attr);
		if ($GLOBALS['core']->blog->settings->shortURL->shortURLEnabled) {
			if ($GLOBALS['core']->blog->settings->shortURL->shortURLEvenShorter) {
				$id = 'dcShortURL::idConversion($_ctx->comments->comment_id)';
			} else {
				$id = '$_ctx->comments->comment_id';
			}
			return '<?php echo '.sprintf($f,'$core->blog->url.$core->url->getBase("shortURLComment").'.
				'"/".rawurlencode('.$id.')').'; ?>';
		}
		return '';
	}
}

class shortURL extends dcUrlHandlers
{
	public static function postById($args)
	{
		$id = $args;
		if (!preg_match('/^\d+$/', $id)) {
			if ($id[0] == 'h') {
				$id = substr($id, 1);
			}
			$id = baseConversion::fromBase($id);
		}
		$params = array('no_content' => 1,
			'post_id' => $id,
			'post_type' => '');
		$password = $GLOBALS['core']->blog->without_password;
		$GLOBALS['core']->blog->withoutPassword(false);

		// Try to find the post
		$result = $GLOBALS['core']->blog->getPosts($params);
		$GLOBALS['core']->blog->withoutPassword($password);
		if (!$result) {
			self::p404();
			return;
		}

		// Try to find the URL to go with it
		$base = $GLOBALS['core']->url->getBase($result->post_type);
		if ($base === null) {
			// try an alternate via the plural of the post_type. Works for pages.
			$base = $GLOBALS['core']->url->getBase($result->post_type.'s');
		}
		if ($base === null) {
			// could not find any suitable URL for this post-type
			self::p404();
			return;
		}

		$url = $GLOBALS['core']->blog->url.$base.'/'.$result->post_url;
		http::head(302, 'Found');
		header('Location: '.$url);
		return;
	}
	
	public static function postByCommentId($args)
	{
		$id = $args;
		if (!preg_match('/^\d+$/', $id)) {
			if ($id[0] == 'h') {
				$id = substr($id, 1);
			}
			$id = baseConversion::fromBase($id);
		}
		$params = array('no_content' => 1,
			'comment_id' => $id,
			'post_type' => '');
		$password = $GLOBALS['core']->blog->without_password;
		$GLOBALS['core']->blog->withoutPassword(false);

		// Try to find the post
		$result = $GLOBALS['core']->blog->getComments($params);
		$GLOBALS['core']->blog->withoutPassword($password);
		if (!$result) {
			self::p404();
			return;
		}

		// Try to find the URL to go with it
		$base = $GLOBALS['core']->url->getBase($result->post_type);
		if ($base === null) {
			// try an alternate via the plural of the post_type. Works for pages.
			$base = $GLOBALS['core']->url->getBase($result->post_type.'s');
		}
		if ($base === null) {
			// could not find any suitable URL for this post-type
			self::p404();
			return;
		}

		$url = $GLOBALS['core']->blog->url.$base.'/'.$result->post_url.'#c'.$result->comment_id;
		http::head(302, 'Found');
		header('Location: '.$url);
		return;
	}
	
}
?>
