<?php

class baseConversion {

	static public function toBase($num)
	{
		$chars = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_-';
		$result = '';
		$base = strlen($chars);
		if (bccomp($num, 0) == 0) {
			$result = '0';
		}
		while (bccomp($num, 0) != 0) {
			$rem = bcmod($num, $base); // Remainder calculation
			$num = bcdiv(bcsub($num, $rem), $base);
			$result = $chars[$rem] . $result;
		}
		return $result;
	}

	static public function fromBase($num)
	{
		$chars = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_-';
		$base = strlen($chars);
		$len = strlen($num);
		$result = '';
		for ($i = $len - 1; $i >= 0; $i--) {
			$char = $num[$i]; // Get the last character from the number
			$value = strpos($chars, $char); // Get the decimal value
			if ($value !== FALSE) {
				$result = bcadd($result, bcmul($value, bcpow($base, $len - $i - 1)));
			} // We simply ignore chars that are not part of the base chars
		}
		return $result;
	}
}
?>
